# /* **************************************************************************
#  *                                                                          *
#  *     (C) Copyright Paul Mensonides 2002.
#  *     Distributed under the Boost Software License, Version 1.0. (See
#  *     accompanying file LICENSE_1_0.txt or copy at
#  *     http://www.boost.org/LICENSE_1_0.txt)
#  *                                                                          *
#  ************************************************************************** */
#
# /* See http://www.boost.org for most recent version. */
#
# ifndef CPPCMS_BOOST_PREPROCESSOR_SEQ_FOR_EACH_PRODUCT_HPP
# define CPPCMS_BOOST_PREPROCESSOR_SEQ_FOR_EACH_PRODUCT_HPP
#
# include <cppcms_boost/preprocessor/arithmetic/dec.hpp>
# include <cppcms_boost/preprocessor/config/config.hpp>
# include <cppcms_boost/preprocessor/control/if.hpp>
# include <cppcms_boost/preprocessor/repetition/for.hpp>
# include <cppcms_boost/preprocessor/seq/seq.hpp>
# include <cppcms_boost/preprocessor/seq/size.hpp>
# include <cppcms_boost/preprocessor/tuple/elem.hpp>
# include <cppcms_boost/preprocessor/tuple/rem.hpp>
#
# /* BOOST_PP_SEQ_FOR_EACH_PRODUCT */
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT(macro, sets) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_E(CPPCMS_BOOST_PP_FOR, macro, sets)
#
# /* BOOST_PP_SEQ_FOR_EACH_PRODUCT_R */
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_R(r, macro, sets) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_E(CPPCMS_BOOST_PP_FOR_ ## r, macro, sets)
#
# if ~CPPCMS_BOOST_PP_CONFIG_FLAGS() & CPPCMS_BOOST_PP_CONFIG_EDG()
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_E(impl, macro, sets) impl((CPPCMS_BOOST_PP_SEQ_HEAD(sets)(nil), CPPCMS_BOOST_PP_SEQ_TAIL(sets)(nil), (nil), macro), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_0)
# else
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_E(impl, macro, sets) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_E_I(impl, macro, sets)
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_E_I(impl, macro, sets) impl((CPPCMS_BOOST_PP_SEQ_HEAD(sets)(nil), CPPCMS_BOOST_PP_SEQ_TAIL(sets)(nil), (nil), macro), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_0)
# endif
#
# if CPPCMS_BOOST_PP_CONFIG_FLAGS() & CPPCMS_BOOST_PP_CONFIG_STRICT()
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P_I data
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P_I(cset, rset, res, macro) CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(cset))
# else
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P(r, data) CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(CPPCMS_BOOST_PP_TUPLE_ELEM(4, 0, data)))
# endif
#
# if ~CPPCMS_BOOST_PP_CONFIG_FLAGS() & CPPCMS_BOOST_PP_CONFIG_MWCC()
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O_I data
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O_I(cset, rset, res, macro) (CPPCMS_BOOST_PP_SEQ_TAIL(cset), rset, res, macro)
# else
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O(r, data) (CPPCMS_BOOST_PP_SEQ_TAIL(CPPCMS_BOOST_PP_TUPLE_ELEM(4, 0, data)), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, data))
# endif
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, i) CPPCMS_BOOST_PP_IF(CPPCMS_BOOST_PP_DEC(CPPCMS_BOOST_PP_SEQ_SIZE(CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, data))), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_ ## i, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I)
#
# if ~CPPCMS_BOOST_PP_CONFIG_FLAGS() & CPPCMS_BOOST_PP_CONFIG_EDG()
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I_I(r, CPPCMS_BOOST_PP_TUPLE_ELEM(4, 0, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, data))
# else
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I_IM(r, CPPCMS_BOOST_PP_TUPLE_REM_4 data)
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I_IM(r, im) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I_I(r, im)
# endif
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_I_I(r, cset, rset, res, macro) macro(r, CPPCMS_BOOST_PP_SEQ_TAIL(res (CPPCMS_BOOST_PP_SEQ_HEAD(cset))))
#
# if ~CPPCMS_BOOST_PP_CONFIG_FLAGS() & CPPCMS_BOOST_PP_CONFIG_MWCC()
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H_I data
# else
#    define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H_I(CPPCMS_BOOST_PP_TUPLE_ELEM(4, 0, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 1, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 2, data), CPPCMS_BOOST_PP_TUPLE_ELEM(4, 3, data))
# endif
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H_I(cset, rset, res, macro) (CPPCMS_BOOST_PP_SEQ_HEAD(rset)(nil), CPPCMS_BOOST_PP_SEQ_TAIL(rset), res (CPPCMS_BOOST_PP_SEQ_HEAD(cset)), macro)
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_0(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 0)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_1(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 1)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_2(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 2)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_3(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 3)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_4(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 4)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_5(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 5)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_6(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 6)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_7(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 7)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_8(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 8)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_9(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 9)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_10(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 10)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_11(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 11)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_12(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 12)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_13(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 13)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_14(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 14)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_15(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 15)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_16(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 16)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_17(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 17)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_18(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 18)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_19(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 19)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_20(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 20)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_21(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 21)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_22(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 22)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_23(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 23)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_24(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 24)(r, data)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_25(r, data) CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_C(data, 25)(r, data)
#
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_0(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_1)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_1(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_2)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_2(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_3)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_3(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_4)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_4(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_5)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_5(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_6)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_6(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_7)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_7(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_8)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_8(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_9)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_9(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_10)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_10(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_11)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_11(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_12)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_12(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_13)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_13(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_14)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_14(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_15)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_15(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_16)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_16(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_17)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_17(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_18)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_18(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_19)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_19(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_20)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_20(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_21)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_21(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_22)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_22(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_23)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_23(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_24)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_24(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_25)
# define CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_N_25(r, data) CPPCMS_BOOST_PP_FOR_ ## r(CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_H(data), CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_P, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_O, CPPCMS_BOOST_PP_SEQ_FOR_EACH_PRODUCT_M_26)
#
# endif
